

#if !defined __WIN_X_H
#define __WIN_X_H

#include <X11/Xlib.h>

#include "WIN_VIRTUAL.h"

#define mbprintf(xxx) printf("%s\n", xxx)


// X window variables
// on SGI's, XWindows RGB pixel format is reverse from OpenGL (???)
class Xwindow : public BLTwindow {

   protected:
      GC            mGC;
      XImage        *xcanvas;
      
      void Xmapcpy(XImage * mcanvas, mapul *tob);

   public:
      // VIRTUAL
      int  VIRTUALreset(int argc, char **argv, int maxx, int maxy, char *winname, void *attribs);
      void VIRTUALswapbuffers();
      void VIRTUALcancel();
      void VIRTUALgetdim(int *w, int *h);
      int  VIRTUALreparent(void *data);

      // BLT
      void BLTbitblt(mapul *mcanvas);
      void BLTbitblt(int framenum, linelist *mcanvas);

      void BLTbitmap(mapul *mcanvas);
      void BLTbitmap(int framenum, linelist *mcanvas);

      void BLTanimate(int numframes, mapul *mcanvas);
      void BLTanimate(linelist *mcanvas);

      // WIN_X
      Display *mdisplay;
      Window  mwindow;

      Xwindow() { xcanvas = NULL; mdisplay = NULL; }
      virtual ~Xwindow() {}
      
      int    Xqtest(unsigned int x);
      int    Xpollkeyboard(char *x);
      int    Xcode2sym(unsigned int x);
      XEvent Xqread(unsigned int *x);
      void   Xqenter(XEvent *mevent);
      
      void   Xline(int x0, int y0, int x1, int y1, unsigned int color, mapul *mcanvas);
      void   Xline(int x0, int y0, int x1, int y1, unsigned int color, XImage *mcanvas);
};


int IOErrorHandler(Display *display);

#endif

